#!/usr/bin/python


false,true=0,1
import strop
import shelve


# configuration parameters
CONFIGFILE="config.dbm"
PORT="port"
HOST="host"
SERVERPATH="serverpath"
CACHEDB="cache.odb"

	
def purge():
	try:
		config = shelve.open(CONFIGFILE)
	except:
		return

	

def setup():
	try:
		config  = shelve.open(CONFIGFILE)
		port    = config[PORT]
		host    = config[HOST]
		server  = config[SERVERPATH]
		cachedb = config[CACHEDB]
		config.close()
	except:
		port = 2001
		host = ""
		server = "./Paos-1.4/Server.py"
		cachedb = "./cache.dbm"
	return (port,host,server,cachedb)
	
def update(port,host,server,cachedb):
	config  = shelve.open(CONFIGFILE)
	config[PORT] = port
	config[HOST] = host
	config[SERVERPATH] = server
	config[CACHEDB] = cachedb
	config.close()

	text = open("./XMLServer.py").read()
	import regex
	x = regex.compile("#__BEGIN__\([^#]+\)")
	pos = x.search(text)
	if pos == -1:			
		print "Cant find #__BEGIN__ in XMLServer.py file"
		return

	length = x.match(text[pos:])
	snipet = """
#__BEGIN__
PAOSPORT=%d
PAOSHOST=\"%s\"
SERVERPATH=\"%s\"
CACHEDB=\"%s\"
"""
	snipet = snipet % (port,host,server,cachedb)

	text = text[:pos-1] + snipet + text[pos+length:]
	open("./XMLServer.py","w").write(text)

def text_header(port,host,server,cachedb):
	print "\n\n\n\n"
	print "****************************************"
	print "*        XML Server configuration      *"
	print "****************************************"
	print "*(P)ort          : %d" % (port)               
	print "*(H)ost          : %s" % (host)               
	print "*(S)erver Path   : %s" % (server)
	print "*(D)Database     : %s" % (cachedb)
	print "***************************************"
	print "* (O)k (C)ancel                       *"
	print "***************************************"
	print "* To modify press [P,H,S,D]           *"
	print "* (O)k or <enter> starts the server   *"
	print "***************************************" 
	

def textmode():
	port,host,server,cachedb = setup()
	
	print "Unable to import Tkinter, resorting to text interface ;)"
	
	while 1:
		text_header(port,host,server,cachedb)
		cmd = strop.upper(raw_input("Command: "))

		if len(cmd) == 0:
			cmd = "O"
		
		if   cmd == "P":
			caption = "Port[%d], new value:" % (port)
			port = strop.atoi(raw_input(caption))
		elif cmd == "H":
			caption = "Host[%s], new value:" % (host)
			host = raw_input(caption)
		elif cmd == "S":
			caption = "Server Path[%s], new value" % (server)
			server = raw_input(caption)
		elif cmd == "D":
			caption = "Database[%s], new value" % (cachedb)
			server = raw_input(caption)
		elif cmd == "O":
			cmd = "nohup python %s %d %s &" % (server,port,cachedb)
			# launch server
			import os
			if os.system(cmd) == 0:
				update(port,host,server,cachedb)	
				print "Server Launched"
			return
		elif cmd == "C":
			return	


class table:
	def __init__(self, f, dict):		
		for (label, value) in dict.items():
			frm = Frame(f)
			frm.pack(side=TOP,expand=YES,fill=BOTH)

			if type(value) == type(0):
				setattr(self, label, IntVar())
			else:
				setattr(self, label, StringVar())		

			getattr(self,label).set( value )

			x = "%s" % (label)
			l = Label(frm,text=x,relief=RIDGE,justify=RIGHT)
			l.pack(side=LEFT,expand=YES,fill=BOTH)
			e = Entry(frm,relief=SUNKEN, textvariable=getattr(self,label))
			e.pack(side=LEFT,expand=YES,fill=BOTH)

	def get(self, obj, dict):
		for k in dict.keys():
			setattr(obj,k,getattr(self,k).get())
		return dict			
										
def guimode():
	class Main(Frame):
		def __init__(self):
			Frame.__init__(self)
			self.port,self.host,self.server,self.database = setup()

			self.master.title(" XML Server configuration ")
			self.pack(side=LEFT,expand=YES,fill=BOTH)

			self.dict = {"port": self.port,
                		"host": self.host,
				"server" : self.server,
				"database": self.database}
			self.t = table(self, self.dict)	
			ok = Button(self, text="Start Paos Server", command=self.ok)
			ok.pack(side=BOTTOM,expand=YES,fill=BOTH)
			cancel = Button(self, text="Abort", command=self.cancel)
			cancel.pack(side=BOTTOM,expand=YES,fill=BOTH)
		def cancel(self):
			sys.exit(0)
		def ok(self):
			self.dict = self.t.get( self, self.dict )
			import os
			cmd = "nohup python %s %d %s &" % (self.server,self.port,self.database)
			# launch server
			if os.system(cmd) == 0:
				update(self.port,self.host,self.server,self.database)	
				print "Server Launched"

			sys.exit(0)	

	Main().mainloop()									 	  	


#----- try gui if not use a text menu
try:
	from Tkinter import *
	import sys
	func = guimode
except:
	func = textmode

func()
